/*#include<opencv\cv.h>
#include<opencv\highgui.h>

using namespace cv;

int main() {
	//Create matrix to store image
	Mat image;
	//initialize capture;

	VideoCapture cap;
	cap.open(1);

	//create window to show image
	namedWindow("window",1);

	while(1) {
		//copy webcam stream to image

		cap>>image;

		//print image to screen
		imshow("window",image);
		//delat 33ms
		waitKey(33);

	}

	return 0;
}*/


/*
#include <iostream>
#include <sstream>
#include <time.h>
#include <Windows.h>

#include <opencv2/core/core.hpp>
#include <opencv2/imgproc/imgproc.hpp>
#include <opencv2/calib3d/calib3d.hpp>
#include <opencv2/highgui/highgui.hpp>

using namespace cv;
using namespace std;

int main(int argc, char* argv[])
{*/
/*	printf("CV_VERSION: %d.%d.%d\n", CV_MAJOR_VERSION,CV_MINOR_VERSION,CV_SUBMINOR_VERSION);
	bool exception = false;
	
	int nPoints = 5;
	CvSize objectSize;
	objectSize.width = 3;
	objectSize.height = nPoints;
	Mat objectPoints(objectSize,CV_64F);// = Mat(camVect);

	CvSize imageSize;
	imageSize.width = 2;
	imageSize.height = nPoints;
	Mat imagePoints(imageSize,CV_64F);

	objectPoints.at<double>(0,0) = -164;
	objectPoints.at<double>(0,1) = 124;
	objectPoints.at<double>(1,0) = -328;
	objectPoints.at<double>(1,1) = 248;
	objectPoints.at<double>(2,0) = 0;
	objectPoints.at<double>(2,1) = 0;
	objectPoints.at<double>(3,0) = 0;
	objectPoints.at<double>(3,1) = 248;
	objectPoints.at<double>(4,0) = -328;
	objectPoints.at<double>(4,1) = 0;



	imagePoints.at<double>(0,0) = 299.747;
	imagePoints.at<double>(0,1) = 219.445;
	imagePoints.at<double>(1,0) = 154.47;
	imagePoints.at<double>(1,1) = 322.409;
	imagePoints.at<double>(2,0) = 444.431;
	imagePoints.at<double>(2,1) = 114.324;
	imagePoints.at<double>(3,0) = 445.253;
	imagePoints.at<double>(3,1) = 326.433;
	imagePoints.at<double>(4,0) = 161.832;
	imagePoints.at<double>(4,1) = 116.834;
	for(int i=0; i<nPoints; i++) {
		objectPoints.at<double>(i,2) = 0.0;
		imagePoints.at<double>(i,1) += 140;
	}
*/
/*
	int nPoints = 5;
	CvSize objectSize;
	objectSize.width = 3;
	objectSize.height = nPoints;
	Mat objectPoints(objectSize,CV_64F);// = Mat(camVect);

	CvSize imageSize;
	imageSize.width = 2;
	imageSize.height = nPoints;
	Mat imagePoints(imageSize,CV_64F);
	int point = 0;
	//for(int w=0; w<2; w++) {
		for(int w=0; w<3; w++) {
				for(int h=0; h<3; h++) {
					if((h+w)%2 == 1) continue;

					objectPoints.at<double>(point,0) =  -5.0 + w*5.0;
					objectPoints.at<double>(point,1) = -5.0 + h*5.0;
					objectPoints.at<double>(point,2) = 0;//+5.0 - w*5.0;

					imagePoints.at<double>(point,0) = -20.0 + w*20.0 + 319.5;
					imagePoints.at<double>(point++,1) = -20 + h*20.0 + 239.5;
					
				}
	}

	double x0 = 5;
	double y0 = 13;
	double z0 = 0;

	for(int point=0; point<nPoints; point++) {
		imagePoints.at<double>(point,0) += x0;
		imagePoints.at<double>(point,1) += y0;
		//objectPoints.at<double>(point,2) += z0;
	}

	double a = 0;
	double b = 0;
	double g = 3.14159;
			double sa = sin(a);
	double sb = sin(b);
	double sg = sin(g);
	double ca = cos(a);
	double cb = cos(b);
	double cg = cos(g);

	CvSize rotSize;
	rotSize.width = 3;
	rotSize.height = 3;
	Mat rot(rotSize,CV_64F);

	//rotation matrix
	rot.at<double>(0,0) = ca*cb;
	rot.at<double>(0,1) =  ca*sb*sg - sa*cg;
	rot.at<double>(0,2) =  ca*sb*cg + sa*sg;
	rot.at<double>(1,0) =  sa*cb;
	rot.at<double>(1,1) = sa*sb*sg + ca*cg;
	rot.at<double>(1,2) = sa*sb*cg - ca*sg;
	rot.at<double>(2,0) = -sb;
	rot.at<double>(2,1) = cb*sg;
	rot.at<double>(2,2) = cb*cg;
	
	objectPoints = objectPoints*rot;



			//Mat A = objectPoints.mul(rot);
	cout << "rot:\n" << rot << "\n";

	Vec<double,5> distCoeffVec;
	distCoeffVec(0) = 0;//-0.3669624087278113;
	distCoeffVec(1) = 0;//-0.07638290902180184;
	distCoeffVec(2) = 0;
	distCoeffVec(3) = 0;
	distCoeffVec(4) = 0;//0.5764668364450144;


   	Mat rvec;
	Mat tvec;
	Mat rmat;
	Mat jacobian;
	CvSize sz;
	sz.width = 3;
	sz.height = 3;
	Mat cameraMatrix(sz,CV_64F);// = Mat(camVect);
	cameraMatrix.at<double>(0,0) = 100;
	cameraMatrix.at<double>(0,1) = 0;
	cameraMatrix.at<double>(0,2) = 319.5;
	cameraMatrix.at<double>(1,0) = 0;
	cameraMatrix.at<double>(1,1) = 100;
	cameraMatrix.at<double>(1,2) = 239.5;
	cameraMatrix.at<double>(2,0) = 0; 
	cameraMatrix.at<double>(2,1) = 0;
	cameraMatrix.at<double>(2,2) = 1; 

	Mat distCoeffs = Mat(distCoeffVec);

	boolean exception = false;		
	try {
		//for(int i=0; i< 10000; i++) {
	solvePnP(objectPoints, imagePoints, cameraMatrix,distCoeffs,rvec,tvec,false);
	Rodrigues(rvec, rmat, jacobian); //	gives results that you must apply to camera to get it into position from 0,0,0, no rotation
//		}
	} catch(...) {
		exception = true;
		cout << "Unable to find board location.\n";
	}

	if(!exception) {
		cout << "objectP:\n " << objectPoints << "\n";
		cout << "imageP:\n " << imagePoints << "\n";
		cout << "cameraMatrix:\n " << cameraMatrix << "\n";
		cout << "distCoeffs:\n " << distCoeffs << "\n";
		cout << "rmat:\n " << rmat << "\n";
		cout << "tvec:\n " << tvec << "\n";

	}
	return 0;
}*/
/*
#include <iostream>
#include <sstream>
#include <time.h>
#include <Windows.h>

#include <opencv2/core/core.hpp>
#include <opencv2/imgproc/imgproc.hpp>
#include <opencv2/calib3d/calib3d.hpp>
#include <opencv2/highgui/highgui.hpp>

using namespace cv;
using namespace std;

int main(int argc, char* argv[])
{
	printf("CV_VERSION: %d.%d.%d\n", CV_MAJOR_VERSION,CV_MINOR_VERSION,CV_SUBMINOR_VERSION);
	bool exception = false;
	vector<Point2d> imageP;

	CvSize objectSize;
	objectSize.width = 3;
	objectSize.height = 12;
	Mat objectPoints(objectSize,CV_64F);// = Mat(camVect);
	

	int point = 0;
	for(int w=0; w<2; w++) {
	//	for(int w=0; w<7; w++) {
				for(int h=0; h<6; h++) {
					objectPoints.at<double>(point,0) = -20.0+w*5.0;
					objectPoints.at<double>(point,1) = -20.0 + h*5.0;
					objectPoints.at<double>(point++,2) = 0.0;
				}
	}



	imageP.push_back(Point2f(122.56181,64.894775));
	imageP.push_back(Point2f(163.85579,63.682297));
	imageP.push_back(Point2f(204.5,62));
	imageP.push_back(Point2f(245.62991,61.093784));
	imageP.push_back(Point2f(283,61));
	imageP.push_back(Point2f(319.81903,61.967384));
	imageP.push_back(Point2f(354.08017,62.274704));
	imageP.push_back(Point2f(123,104.5));
	imageP.push_back(Point2f(164.5,102.5));
	imageP.push_back(Point2f(204.5,100.5));
	imageP.push_back(Point2f(244,99.5));
	imageP.push_back(Point2f(281.5,99));
//	/*imageP.push_back(Point2f(318.5, 99));
//	imageP.push_back(Point2f(353.72653, 96.017204));
//	imageP.push_back(Point2f(124.62646,144.43448));
//	imageP.push_back(Point2f(165.5,142.5));
//	imageP.push_back(Point2f(206.03426,140.04895)); 
//	imageP.push_back(Point2f(245,138.5));
//	imageP.push_back(Point2f(283,137.5));
//	imageP.push_back(Point2f(319,136));
//	imageP.push_back(Point2f(354.5,134.5));
//	imageP.push_back(Point2f(127.50209,184.51553));
//	imageP.push_back(Point2f(167.5,181.5));
//	imageP.push_back(Point2f(207,179));
//	imageP.push_back(Point2f(245.5,177));
//	imageP.push_back(Point2f(283,175));
//	imageP.push_back(Point2f(318.88574,174.8522));
//	imageP.push_back(Point2f(353.5,170.5));
//	imageP.push_back(Point2f(128.28163,224.11998));
//	imageP.push_back(Point2f(169,220.5));
//	imageP.push_back(Point2f(210.13632,217.0213));
//	imageP.push_back(Point2f(247,214.5));
//	imageP.push_back(Point2f(282.64105,212.52209));
//	imageP.push_back(Point2f(319.19608,209.22551));
//	imageP.push_back(Point2f(343,206));
//	imageP.push_back(Point2f(134,260.5));
//	imageP.push_back(Point2f(172.92181,256.8718));
//	imageP.push_back(Point2f(211,255));
//	imageP.push_back(Point2f(248.5,250.5));
//	imageP.push_back(Point2f(285,248));
//	imageP.push_back(Point2f(319.5,243));
//	imageP.push_back(Point2f(353.30963,240.85687));

	vector<Point3d> camVect;
	camVect.push_back(Point3d(654.8611202347574,0,319.5));
	camVect.push_back(Point3d(0,654.8611202347574,239.5));
	camVect.push_back(Point3d(0,0,1));

	Vec<double,5> distCoeffVec;
	distCoeffVec(0) = -0.3669624087278113;
	distCoeffVec(1) = -0.07638290902180184;
	distCoeffVec(2) = 0;
	distCoeffVec(3) = 0;
	distCoeffVec(4) = 0.5764668364450144;


   	Mat rvec;
	Mat tvec;
	Mat rmat;
	Mat jacobian;
	CvSize sz;
	sz.width = 3;
	sz.height = 3;
	Mat cameraMatrix(sz,CV_64F);// = Mat(camVect);
	cameraMatrix.at<double>(0,0) = 654.8611202347574;
	cameraMatrix.at<double>(0,1) = 0;
	cameraMatrix.at<double>(0,2) = 319.5;
	cameraMatrix.at<double>(1,0) = 0;
	cameraMatrix.at<double>(1,1) = 654.8611202347574;
	cameraMatrix.at<double>(1,2) = 239.5;
	cameraMatrix.at<double>(2,0) = 0; 
	cameraMatrix.at<double>(2,1) = 0;
	cameraMatrix.at<double>(2,2) = 1; 

	Mat distCoeffs = Mat(distCoeffVec);

			
	try {
		//for(int i=0; i< 10000; i++) {
	solvePnP(objectPoints, Mat(imageP), cameraMatrix,distCoeffs,rvec,tvec,false);
	Rodrigues(rvec, rmat, jacobian);
//		}
	} catch(...) {
		exception = true;
		cout << "Unable to find board location.\n";
	}

	if(!exception) {
		cout << "objectP: " << objectPoints << "\n";
		cout << "imageP: " << Mat(imageP) << "\n";
		cout << "cameraMatrix: " << cameraMatrix << "\n";
		cout << "distCoeffs: " << distCoeffs << "\n";
		cout << "rmat: " << rmat << "\n";
		cout << "tvec: " << tvec << "\n";

	}
	return 0;
}*/


#include <iostream>
#include <sstream>
#include <time.h>
#include <Windows.h>

#include <opencv2/core/core.hpp>
#include <opencv2/imgproc/imgproc.hpp>
#include <opencv2/calib3d/calib3d.hpp>
#include <opencv2/highgui/highgui.hpp>

using namespace cv;
using namespace std;

void help()
{
    cout <<  "This is a camera calibration sample." << endl
         <<  "Usage: calibration configurationFile"  << endl
         <<  "Near the sample file you'll find the configuration file, which has detailed help of "
             "how to edit it.  It may be any OpenCV supported file format XML/YAML." << endl;
}
class Settings
{
public:
    Settings() : goodInput(false) {}
    enum Pattern { NOT_EXISTING, CHESSBOARD, CIRCLES_GRID, ASYMMETRIC_CIRCLES_GRID };
    enum InputType {INVALID, CAMERA, VIDEO_FILE, IMAGE_LIST};

    void write(FileStorage& fs) const                        //Write serialization for this class
    {
        fs << "{" << "BoardSize_Width"  << boardSize.width
                  << "BoardSize_Height" << boardSize.height
                  << "Square_Size"         << squareSize
                  << "Calibrate_Pattern" << patternToUse
                  << "Calibrate_NrOfFrameToUse" << nrFrames
                  << "Calibrate_FixAspectRatio" << aspectRatio
                  << "Calibrate_AssumeZeroTangentialDistortion" << calibZeroTangentDist
                  << "Calibrate_FixPrincipalPointAtTheCenter" << calibFixPrincipalPoint

                  << "Write_DetectedFeaturePoints" << bwritePoints
                  << "Write_extrinsicParameters"   << bwriteExtrinsics
                  << "Write_outputFileName"  << outputFileName

                  << "Show_UndistortedImage" << showUndistorsed

                  << "Input_FlipAroundHorizontalAxis" << flipVertical
                  << "Input_Delay" << delay
                  << "Input" << input
           << "}";
    }
    void read(const FileNode& node)                          //Read serialization for this class
    {
        node["BoardSize_Width" ] >> boardSize.width;
        node["BoardSize_Height"] >> boardSize.height;
        node["Calibrate_Pattern"] >> patternToUse;
        node["Square_Size"]  >> squareSize;
        node["Calibrate_NrOfFrameToUse"] >> nrFrames;
        node["Calibrate_FixAspectRatio"] >> aspectRatio;
        node["Write_DetectedFeaturePoints"] >> bwritePoints;
        node["Write_extrinsicParameters"] >> bwriteExtrinsics;
        node["Write_outputFileName"] >> outputFileName;
        node["Calibrate_AssumeZeroTangentialDistortion"] >> calibZeroTangentDist;
        node["Calibrate_FixPrincipalPointAtTheCenter"] >> calibFixPrincipalPoint;
        node["Input_FlipAroundHorizontalAxis"] >> flipVertical;
        node["Show_UndistortedImage"] >> showUndistorsed;
        node["Input"] >> input;
        node["Input_Delay"] >> delay;
        interprate();
    }
    void interprate()
    {
        goodInput = true;
        if (boardSize.width <= 0 || boardSize.height <= 0)
        {
            cerr << "Invalid Board size: " << boardSize.width << " " << boardSize.height << endl;
            goodInput = false;
        }
        if (squareSize <= 10e-6)
        {
            cerr << "Invalid square size " << squareSize << endl;
            goodInput = false;
        }
        if (nrFrames <= 0)
        {
            cerr << "Invalid number of frames " << nrFrames << endl;
            goodInput = false;
        }

        if (input.empty())      // Check for valid input
                inputType = INVALID;
        else
        {
            if (input[0] >= '0' && input[0] <= '9')
            {
                stringstream ss(input);
                ss >> cameraID;
                inputType = CAMERA;
            }
            else
            {
                if (readStringList(input, imageList))
                    {
                        inputType = IMAGE_LIST;
                        nrFrames = (nrFrames < imageList.size()) ? nrFrames : imageList.size();
                    }
                else
                    inputType = VIDEO_FILE;
            }
            if (inputType == CAMERA)
                inputCapture.open(cameraID);
            if (inputType == VIDEO_FILE)
                inputCapture.open(input);
            if (inputType != IMAGE_LIST && !inputCapture.isOpened())
                    inputType = INVALID;
        }
        if (inputType == INVALID)
        {
            cerr << " Inexistent input: " << input;
            goodInput = false;
        }

        flag = 0;
        if(calibFixPrincipalPoint) flag |= CV_CALIB_FIX_PRINCIPAL_POINT;
        if(calibZeroTangentDist)   flag |= CV_CALIB_ZERO_TANGENT_DIST;
        if(aspectRatio)            flag |= CV_CALIB_FIX_ASPECT_RATIO;


        calibrationPattern = NOT_EXISTING;
        if (!patternToUse.compare("CHESSBOARD")) calibrationPattern = CHESSBOARD;
        if (!patternToUse.compare("CIRCLES_GRID")) calibrationPattern = CIRCLES_GRID;
        if (!patternToUse.compare("ASYMMETRIC_CIRCLES_GRID")) calibrationPattern = ASYMMETRIC_CIRCLES_GRID;
        if (calibrationPattern == NOT_EXISTING)
            {
                cerr << " Inexistent camera calibration mode: " << patternToUse << endl;
                goodInput = false;
            }
        atImageList = 0;

    }
    Mat nextImage()
    {
        Mat result;
        if( inputCapture.isOpened() )
        {
            Mat view0;
            inputCapture >> view0;
            view0.copyTo(result);
        }
        else if( atImageList < (int)imageList.size() )
            result = imread(imageList[atImageList++], CV_LOAD_IMAGE_COLOR);

        return result;
    }

    static bool readStringList( const string& filename, vector<string>& l )
    {
        l.clear();
        FileStorage fs(filename, FileStorage::READ);
        if( !fs.isOpened() )
            return false;
        FileNode n = fs.getFirstTopLevelNode();
        if( n.type() != FileNode::SEQ )
            return false;
        FileNodeIterator it = n.begin(), it_end = n.end();
        for( ; it != it_end; ++it )
            l.push_back((string)*it);
        return true;
    }
public:
    Size boardSize;            // The size of the board -> Number of items by width and height
    Pattern calibrationPattern;// One of the Chessboard, circles, or asymmetric circle pattern
    float squareSize;          // The size of a square in your defined unit (point, millimeter,etc).
    int nrFrames;              // The number of frames to use from the input for calibration
    float aspectRatio;         // The aspect ratio
    int delay;                 // In case of a video input
    bool bwritePoints;         //  Write detected feature points
    bool bwriteExtrinsics;     // Write extrinsic parameters
    bool calibZeroTangentDist; // Assume zero tangential distortion
    bool calibFixPrincipalPoint;// Fix the principal point at the center
    bool flipVertical;          // Flip the captured images around the horizontal axis
    string outputFileName;      // The name of the file where to write
    bool showUndistorsed;       // Show undistorted images after calibration
    string input;               // The input ->



    int cameraID;
    vector<string> imageList;
    int atImageList;
    VideoCapture inputCapture;
    InputType inputType;
    bool goodInput;
    int flag;

private:
    string patternToUse;


};

void write(FileStorage& fs, const std::string&, const Settings& x)
{
    x.write(fs);
}
void read(const FileNode& node, Settings& x, const Settings& default_value = Settings())
{
    if(node.empty())
        x = default_value;
    else
        x.read(node);
}

enum { DETECTION = 0, CAPTURING = 1, CALIBRATED = 2 };

bool runCalibrationAndSave(Settings& s, Size imageSize, Mat&  cameraMatrix, Mat& distCoeffs,
                           vector<vector<Point2f> > imagePoints );

int main(int argc, char* argv[])
{

	LPWSTR buf = (LPWSTR) malloc(512*sizeof(LPWSTR));
	GetCurrentDirectory(512, buf);
	printf("Working directory: %ls\n", buf);
	free(buf);

    help();
    Settings s;
	FILE* fp;
	fp = fopen("VID5_in.xml", "r");
	printf("file: %d\n", fp);
	fclose(fp);
    const string inputSettingsFile = argc > 1 ? argv[1] : "VID5_in.xml";
    FileStorage fs(inputSettingsFile, FileStorage::READ); // Read the settings
    if (!fs.isOpened())
    {
        cout << "Could not open the configuration file: \"" << inputSettingsFile << "\"" << endl;
        return -1;
    }
    fs["Settings"] >> s;
    fs.release();                                         // close Settings file

    if (!s.goodInput)
    {
        cout << "Invalid input detected. Application stopping. " << endl;
        return -1;
    }

    vector<vector<Point2f> > imagePoints;
    Mat cameraMatrix, distCoeffs;
    Size imageSize;
    int mode = s.inputType == Settings::IMAGE_LIST ? CAPTURING : DETECTION;
    clock_t prevTimestamp = 0;
    const Scalar RED(0,0,255), GREEN(0,255,0);
    const char ESC_KEY = 27;

    for(int i = 0;;++i)
    {
      Mat view;
      bool blinkOutput = false;

      view = s.nextImage();

      //-----  If no more image, or got enough, then stop calibration and show result -------------
      if( mode == CAPTURING && imagePoints.size() >= (unsigned)s.nrFrames )
      {
          if( runCalibrationAndSave(s, imageSize,  cameraMatrix, distCoeffs, imagePoints))
              mode = CALIBRATED;
          else
              mode = DETECTION;
      }
      if(view.empty())          // If no more images then run calibration, save and stop loop.
      {
            if( imagePoints.size() > 0 )
                runCalibrationAndSave(s, imageSize,  cameraMatrix, distCoeffs, imagePoints);
            break;
      }


        imageSize = view.size();  // Format input image.
        if( s.flipVertical )    flip( view, view, 0 );

        vector<Point2f> pointBuf;

        bool found = false;
	//	if(mode!=CALIBRATED) {
			Mat rvec;
			Mat tvec;
			Mat rmat;
			Mat jacobian;
			vector<Point3f> objectP;
	vector<Point2f> imageP;
			
	imageP.push_back(Point2f(122.56181,64.894775));
	imageP.push_back(Point2f(163.85579,63.682297));
	imageP.push_back(Point2f(204.5,62));
	imageP.push_back(Point2f(245.62991,61.093784));
	imageP.push_back(Point2f(283,61));
	imageP.push_back(Point2f(319.81903,61.967384));
	imageP.push_back(Point2f(354.08017,62.274704));
	imageP.push_back(Point2f(123,104.5));
	imageP.push_back(Point2f(164.5,102.5));
	imageP.push_back(Point2f(204.5,100.5));
	imageP.push_back(Point2f(244,99.5));
	imageP.push_back(Point2f(281.5,99));
	imageP.push_back(Point2f(318.5, 99));
	imageP.push_back(Point2f(353.72653, 96.017204));
	imageP.push_back(Point2f(124.62646,144.43448));
	imageP.push_back(Point2f(165.5,142.5));
	imageP.push_back(Point2f(206.03426,140.04895)); 
	imageP.push_back(Point2f(245,138.5));
	imageP.push_back(Point2f(283,137.5));
	imageP.push_back(Point2f(319,136));
	imageP.push_back(Point2f(354.5,134.5));
	imageP.push_back(Point2f(127.50209,184.51553));
	imageP.push_back(Point2f(167.5,181.5));
	imageP.push_back(Point2f(207,179));
	imageP.push_back(Point2f(245.5,177));
	imageP.push_back(Point2f(283,175));
	imageP.push_back(Point2f(318.88574,174.8522));
	imageP.push_back(Point2f(353.5,170.5));
	imageP.push_back(Point2f(128.28163,224.11998));
	imageP.push_back(Point2f(169,220.5));
	imageP.push_back(Point2f(210.13632,217.0213));
	imageP.push_back(Point2f(247,214.5));
	imageP.push_back(Point2f(282.64105,212.52209));
	imageP.push_back(Point2f(319.19608,209.22551));
	imageP.push_back(Point2f(343,206));
	imageP.push_back(Point2f(134,260.5));
	imageP.push_back(Point2f(172.92181,256.8718));
	imageP.push_back(Point2f(211,255));
	imageP.push_back(Point2f(248.5,250.5));
	imageP.push_back(Point2f(285,248));
	imageP.push_back(Point2f(319.5,243));
	imageP.push_back(Point2f(353.30963,240.85687));

		vector<Point3d> camVect;
	camVect.push_back(Point3d(654.8611202347574,0,319.5));
	camVect.push_back(Point3d(0,654.8611202347574,239.5));
	camVect.push_back(Point3d(0,0,1));

	Vec<double,5> distCoeffVec;
	distCoeffVec(0) = -0.3669624087278113;
	distCoeffVec(1) = -0.07638290902180184;
	distCoeffVec(2) = 0;
	distCoeffVec(3) = 0;
	distCoeffVec(4) = 0.5764668364450144;
		
			for(int w=0; w<7; w++) {
						for(int h=0; h<6; h++) {
							objectP.push_back(Point3f(-20.0+w*5.0,-20.0 + h*5.0,0.0));
						}
			}
			
			switch( s.calibrationPattern ) // Find feature points on the input format
			{
			case Settings::CHESSBOARD:
				found = findChessboardCorners( view, s.boardSize, pointBuf,
					CV_CALIB_CB_ADAPTIVE_THRESH | CV_CALIB_CB_FAST_CHECK | CV_CALIB_CB_NORMALIZE_IMAGE);
					if(mode==CALIBRATED) {
						bool exception = false;
						try {

						//solvePnP(Mat(objectP), Mat(pointBuf), cameraMatrix,distCoeffs,rvec,tvec,false); //changing points
						//Rodrigues(rvec, rmat, jacobian);
						} catch(...) {
							exception = true;
					//		cout << "Unable to find board location.\n";
						}
						if(!exception) {
						//	cout << "objectP: " << objectP << "\n";
						//	cout << "imageP: " << pointBuf << "\n";
						//	cout << "cameraMatrix: " << cameraMatrix << "\n";
						//	cout << "distCoeffs: " << distCoeffs << "\n";
						//	cout << "tvec: " << tvec << "\n";
						//	cout << "rmat: " << rmat << "\n";
						}
					}
				break;
			case Settings::CIRCLES_GRID:
				found = findCirclesGrid( view, s.boardSize, pointBuf );
				break;
			case Settings::ASYMMETRIC_CIRCLES_GRID:
				found = findCirclesGrid( view, s.boardSize, pointBuf, CALIB_CB_ASYMMETRIC_GRID );
				break;
			}
	//	}

        if ( found)                // If done with success,
        {
              // improve the found corners' coordinate accuracy for chessboard
                if( s.calibrationPattern == Settings::CHESSBOARD)
                {
                    Mat viewGray;
                    cvtColor(view, viewGray, CV_BGR2GRAY);
                    cornerSubPix( viewGray, pointBuf, Size(11,11),
                        Size(-1,-1), TermCriteria( CV_TERMCRIT_EPS+CV_TERMCRIT_ITER, 30, 0.1 ));
                }

                if( mode == CAPTURING &&  // For camera only take new samples after delay time
                    (!s.inputCapture.isOpened() || clock() - prevTimestamp > s.delay*1e-3*CLOCKS_PER_SEC) )
                {
                    imagePoints.push_back(pointBuf);
                    prevTimestamp = clock();
                    blinkOutput = s.inputCapture.isOpened();
                }

                // Draw the corners.
                drawChessboardCorners( view, s.boardSize, Mat(pointBuf), found );
        }

        //----------------------------- Output Text ------------------------------------------------
        string msg = (mode == CAPTURING) ? "100/100" :
                      mode == CALIBRATED ? "Calibrated" : "Press 'g' to start";
        int baseLine = 0;
        Size textSize = getTextSize(msg, 1, 1, 1, &baseLine);
        Point textOrigin(view.cols - 2*textSize.width - 10, view.rows - 2*baseLine - 10);

        if( mode == CAPTURING )
        {
            if(s.showUndistorsed)
                msg = format( "%d/%d Undist", (int)imagePoints.size(), s.nrFrames );
            else
                msg = format( "%d/%d", (int)imagePoints.size(), s.nrFrames );
        }

        putText( view, msg, textOrigin, 1, 1, mode == CALIBRATED ?  GREEN : RED);

        if( blinkOutput )
            bitwise_not(view, view);

        //------------------------- Video capture  output  undistorted ------------------------------
        if( mode == CALIBRATED && s.showUndistorsed )
        {
            Mat temp = view.clone();
            undistort(temp, view, cameraMatrix, distCoeffs);
        }

        //------------------------------ Show image and check for input commands -------------------
        imshow("Image View", view);
        char key =  waitKey(s.inputCapture.isOpened() ? 50 : s.delay);

        if( key  == ESC_KEY )
            break;

        if( key == 'u' && mode == CALIBRATED )
           s.showUndistorsed = !s.showUndistorsed;

        if( s.inputCapture.isOpened() && key == 'g' )
        {
            mode = CAPTURING;
            imagePoints.clear();
        }
    }

    // -----------------------Show the undistorted image for the image list ------------------------
    if( s.inputType == Settings::IMAGE_LIST && s.showUndistorsed )
    {
        Mat view, rview, map1, map2;
        initUndistortRectifyMap(cameraMatrix, distCoeffs, Mat(),
            getOptimalNewCameraMatrix(cameraMatrix, distCoeffs, imageSize, 1, imageSize, 0),
            imageSize, CV_16SC2, map1, map2);

        for(int i = 0; i < (int)s.imageList.size(); i++ )
        {
            view = imread(s.imageList[i], 1);
            if(view.empty())
                continue;
            remap(view, rview, map1, map2, INTER_LINEAR);
            imshow("Image View", rview);
            char c = waitKey();
            if( c  == ESC_KEY || c == 'q' || c == 'Q' )
                break;
        }
    }


    return 0;
}

double computeReprojectionErrors( const vector<vector<Point3f> >& objectPoints,
                                  const vector<vector<Point2f> >& imagePoints,
                                  const vector<Mat>& rvecs, const vector<Mat>& tvecs,
                                  const Mat& cameraMatrix , const Mat& distCoeffs,
                                  vector<float>& perViewErrors)
{
    vector<Point2f> imagePoints2;
    int i, totalPoints = 0;
    double totalErr = 0, err;
    perViewErrors.resize(objectPoints.size());

    for( i = 0; i < (int)objectPoints.size(); ++i )
    {
        projectPoints( Mat(objectPoints[i]), rvecs[i], tvecs[i], cameraMatrix,
                       distCoeffs, imagePoints2);
        err = norm(Mat(imagePoints[i]), Mat(imagePoints2), CV_L2);

        int n = (int)objectPoints[i].size();
        perViewErrors[i] = (float) std::sqrt(err*err/n);
        totalErr        += err*err;
        totalPoints     += n;
    }

    return std::sqrt(totalErr/totalPoints);
}

void calcBoardCornerPositions(Size boardSize, float squareSize, vector<Point3f>& corners,
                          Settings::Pattern patternType )
{
    corners.clear();

    switch(patternType)
    {
    case Settings::CHESSBOARD:
    case Settings::CIRCLES_GRID:
        for( int i = 0; i < boardSize.height; ++i )
            for( int j = 0; j < boardSize.width; ++j )
                corners.push_back(Point3f(float( j*squareSize ), float( i*squareSize ), 0));
        break;

    case Settings::ASYMMETRIC_CIRCLES_GRID:
        for( int i = 0; i < boardSize.height; i++ )
            for( int j = 0; j < boardSize.width; j++ )
                corners.push_back(Point3f(float((2*j + i % 2)*squareSize), float(i*squareSize), 0));
        break;
    }
}

bool runCalibration( Settings& s, Size& imageSize, Mat& cameraMatrix, Mat& distCoeffs,
                    vector<vector<Point2f> > imagePoints, vector<Mat>& rvecs, vector<Mat>& tvecs,
                    vector<float>& reprojErrs,  double& totalAvgErr)
{

    cameraMatrix = Mat::eye(3, 3, CV_64F);
    if( s.flag & CV_CALIB_FIX_ASPECT_RATIO )
        cameraMatrix.at<double>(0,0) = 1.0;

    distCoeffs = Mat::zeros(8, 1, CV_64F);

    vector<vector<Point3f> > objectPoints(1);
    calcBoardCornerPositions(s.boardSize, s.squareSize, objectPoints[0], s.calibrationPattern);

    objectPoints.resize(imagePoints.size(),objectPoints[0]);

    //Find intrinsic and extrinsic camera parameters
    double rms = calibrateCamera(objectPoints, imagePoints, imageSize, cameraMatrix,
                                 distCoeffs, rvecs, tvecs, s.flag|CV_CALIB_FIX_K4|CV_CALIB_FIX_K5);

    cout << "Re-projection error reported by calibrateCamera: "<< rms << endl;

    bool ok = checkRange(cameraMatrix) && checkRange(distCoeffs);

    totalAvgErr = computeReprojectionErrors(objectPoints, imagePoints,
                                             rvecs, tvecs, cameraMatrix, distCoeffs, reprojErrs);

    return ok;
}

// Print camera parameters to the output file
void saveCameraParams( Settings& s, Size& imageSize, Mat& cameraMatrix, Mat& distCoeffs,
                        const vector<Mat>& rvecs, const vector<Mat>& tvecs,
                       const vector<float>& reprojErrs, const vector<vector<Point2f> >& imagePoints,
                       double totalAvgErr )
{
    FileStorage fs( s.outputFileName, FileStorage::WRITE );
	cout <<"\nOutput file name:" << s.outputFileName << "\n";
    time_t t;
    time( &t );
    struct tm *t2 = localtime( &t );
    char buf[1024];
    strftime( buf, sizeof(buf)-1, "%c", t2 );

    fs << "calibration_Time" << buf;

    if( !rvecs.empty() || !reprojErrs.empty() )
        fs << "nrOfFrames" << (int)std::max(rvecs.size(), reprojErrs.size());
    fs << "image_Width" << imageSize.width;
    fs << "image_Height" << imageSize.height;
    fs << "board_Width" << s.boardSize.width;
    fs << "board_Height" << s.boardSize.height;
    fs << "square_Size" << s.squareSize;

    if( s.flag & CV_CALIB_FIX_ASPECT_RATIO )
        fs << "FixAspectRatio" << s.aspectRatio;

    if( s.flag )
    {
        sprintf( buf, "flags: %s%s%s%s",
            s.flag & CV_CALIB_USE_INTRINSIC_GUESS ? " +use_intrinsic_guess" : "",
            s.flag & CV_CALIB_FIX_ASPECT_RATIO ? " +fix_aspectRatio" : "",
            s.flag & CV_CALIB_FIX_PRINCIPAL_POINT ? " +fix_principal_point" : "",
            s.flag & CV_CALIB_ZERO_TANGENT_DIST ? " +zero_tangent_dist" : "" );
        cvWriteComment( *fs, buf, 0 );

    }

    fs << "flagValue" << s.flag;

    fs << "Camera_Matrix" << cameraMatrix;
    fs << "Distortion_Coefficients" << distCoeffs;

    fs << "Avg_Reprojection_Error" << totalAvgErr;
    if( !reprojErrs.empty() )
        fs << "Per_View_Reprojection_Errors" << Mat(reprojErrs);

    if( !rvecs.empty() && !tvecs.empty() )
    {
        CV_Assert(rvecs[0].type() == tvecs[0].type());
        Mat bigmat((int)rvecs.size(), 6, rvecs[0].type());
        for( int i = 0; i < (int)rvecs.size(); i++ )
        {
            Mat r = bigmat(Range(i, i+1), Range(0,3));
            Mat t = bigmat(Range(i, i+1), Range(3,6));

            CV_Assert(rvecs[i].rows == 3 && rvecs[i].cols == 1);
            CV_Assert(tvecs[i].rows == 3 && tvecs[i].cols == 1);
            //*.t() is MatExpr (not Mat) so we can use assignment operator
            r = rvecs[i].t();
            t = tvecs[i].t();
        }
        cvWriteComment( *fs, "a set of 6-tuples (rotation vector + translation vector) for each view", 0 );
        fs << "Extrinsic_Parameters" << bigmat;
    }

    if( !imagePoints.empty() )
    {
        Mat imagePtMat((int)imagePoints.size(), imagePoints[0].size(), CV_32FC2);
        for( int i = 0; i < (int)imagePoints.size(); i++ )
        {
            Mat r = imagePtMat.row(i).reshape(2, imagePtMat.cols);
            Mat imgpti(imagePoints[i]);
            imgpti.copyTo(r);
        }
        fs << "Image_points" << imagePtMat;
    }
}

bool runCalibrationAndSave(Settings& s, Size imageSize, Mat&  cameraMatrix, Mat& distCoeffs,vector<vector<Point2f> > imagePoints )
{
    vector<Mat> rvecs, tvecs;
    vector<float> reprojErrs;
    double totalAvgErr = 0;

    bool ok = runCalibration(s,imageSize, cameraMatrix, distCoeffs, imagePoints, rvecs, tvecs,
                             reprojErrs, totalAvgErr);
    cout << (ok ? "Calibration succeeded" : "Calibration failed")
        << ". avg re projection error = "  << totalAvgErr ;

    if( ok )
        saveCameraParams( s, imageSize, cameraMatrix, distCoeffs, rvecs ,tvecs, reprojErrs,
                            imagePoints, totalAvgErr);
    return ok;
}

